config/routes.rb
Rails.application.routes.draw do

  root 'home#index'

  get 'all_papers', to: 'home#all_papers', as: :all_papers
  get 'about', to: 'home#about', as: :about

  
  devise_for :users

  devise_scope :user do
    delete 'sign_out', to: 'devise/sessions#destroy', as: :sign_out
    get 'sign_in', to: 'devise/sessions#new', as: :sign_in
    get 'sign_up', to: 'devise/registrations#new', as: :sign_up
  end

  resources :papers

  # resources :users do
  #   resources :papers
  # end

  # resources :papers do
  #   resources :users
  # end
  
  


  # get '/all_papers', to: 'papers#all', as: :all_papers
  # resources :papers
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/paper.rb
class Paper < ApplicationRecord
  has_many :paper_users
  has_many :users, through: :paper_users

  def submission_date
    return updated_at.localtime.to_formatted_s(:long)
  end
end

app/models/paper_user.rb
class PaperUser < ApplicationRecord
  belongs_to :paper
  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :trackable

  has_many :paper_users
  has_many :papers, through: :paper_users

  def full_name
    if middle_name.blank?
      "#{first_name} #{last_name}"
    else
      "#{first_name} #{middle_name} #{last_name}"
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base

    before_action :update_sanitized_params, if: :devise_controller?

    def update_sanitized_params
        devise_parameter_sanitizer.permit(:sign_up, keys: [:username, :email, :password, :first_name, :middle_name, :last_name, :dob])
    end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
  end

  def all_papers
    @papers = Paper.all
  end
end

app/controllers/papers_controller.rb
class PapersController < ApplicationController
  before_action :set_paper, only: %i[ show edit update destroy ]
  before_action :authenticate_user!, except: [:show, :all]
  before_action :valid_paper_of_current_user, only: [:show, :edit, :update, :destroy]

  def all
    @papers = Paper.all
  end

  # GET /user/1/papers
  def index
    @papers = current_user.papers.all
  end

  # GET /papers/1 or /papers/1.json
  def show
    @user = current_user
  end

  # GET /papers/new
  def new
    # @paper = Paper.new
    @paper = current_user.papers.new
  end

  # GET /papers/1/edit
  def edit
  end

  # POST /papers or /papers.json
  def create
    respond_to do |format|
      if current_user.papers.create(paper_params)
        format.html { redirect_to papers_url, notice: "Paper was successfully created." }
        format.json { render :show, status: :created, location: @paper }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @paper.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /papers/1 or /papers/1.json
  def update
    respond_to do |format|
      if @paper.update(paper_params)
        format.html { redirect_to @paper, notice: "Paper was successfully updated." }
        format.json { render :show, status: :ok, location: @paper }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @paper.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /papers/1 or /papers/1.json
  def destroy
    @paper = Paper.find(params[:id])
    respond_to do |format|
      if current_user.papers.destroy(@paper)
        format.html { redirect_to papers_url, notice: "Paper was successfully destroyed." }
        format.json { head :no_content }
      else
        format.html { redirect_to papers_url, alert: "Sorry, Paper could not be deleted !" }
        format.json { head :no_content }
      end
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_paper
      begin
        @paper = current_user.papers.find(params[:id])
      rescue ActiveRecord::RecordNotFound
        redirect_to papers_path, alert: "You are not authorized to perform this action."
      end
    end

    # Only allow a list of trusted parameters through.
    def paper_params
      params.require(:paper).permit(:title, :abstract, :submission_date, :pdf_link, :decision)
    end

    def valid_paper_of_current_user
      begin
        current_user.papers.find(params[:id]) 
      rescue ActiveRecord::RecordNotFound
        redirect_to papers_path, alert: "You are not authorized to perform this action."
      end
    end

end

app/helpers/application_helper.rb
module ApplicationHelper
    def active_class(path)
        return request.path == path ? 'nav-link active' : 'nav-link'
    end
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/papers_helper.rb
module PapersHelper
end

app/views/home/_header.html.erb
<nav class="navbar navbar-expand-lg navbar-dark bg-primary">
  <div class="container-fluid">
    <%= link_to 'Rails-Conference', root_path, class: 'navbar-brand' %>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <%= link_to 'Home', root_path, class: active_class(root_path) %>
        </li>
        <li class="nav-item">
          <%= link_to 'All Papers', all_papers_path, class: active_class(all_papers_path) %>
        </li>
        <li class="nav-item">
          <%= link_to 'About Us', about_path, class: active_class(about_path) %>
        </li>
        <% if user_signed_in? %>
          <li class="nav-item">
            <%= link_to 'Edit Profile', edit_user_registration_path, class: active_class(edit_user_registration_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'My Papers', papers_path, class: active_class(papers_path) %>
          </li>
        <% end %>
      </ul>
      <ul class="navbar-nav mr-auto mb-2 mb-lg-0">
        <% if user_signed_in? %>
          <li class="nav-item text-light">
            <%= link_to "Signed in as" + ' ' + current_user.full_name, edit_user_registration_path, class: 'nav-link' %>
          </li>
          <li class="nav-item">
            <%= link_to 'Sign Out', sign_out_path, method: :delete, class: 'btn btn-outline-light text-light' %>
          </li>
        <% else %>
          <li class="nav-item">
            <%= link_to 'Sign Up', sign_up_path, class: active_class(sign_up_path) %>
          </li>
          <li class="nav-item">
            <%= link_to 'Sign In', sign_in_path, class: 'btn btn-outline-light text-light' %>
          </li>
        <% end %>
      </ul>
    </div>
  </div>
</nav>

app/views/home/about.html.erb
<h3>This page contains About Us</h3>

app/views/home/all_papers.html.erb
<h1>All Papers</h1>
<table class="table table-hover">
  <thead>
    <tr class="table-primary ">
      <th scope="col">Title</th>
      <th scope="col">Abstract</th>
      <th scope="col">Submission date</th>
      <th scope="col">Pdf link</th>
      <th scope="col">Decision</th>
      <%# <th scope="col">User</th> %>
    </tr>
  </thead>
  <tbody>
    <% @papers.each do |paper| %>
      <tr>
        <td scope="row"><%= paper.title %></td>
        <td><%= paper.abstract %></td>
        <td><%= paper.updated_at.to_formatted_s(:long) %></td>
        <td><%= paper.pdf_link %></td>
        <td><%= paper.decision %></td>
        <%# <td><%= #paper.users.first.first_name %></td>
    </tr>
  <% end %>
</tbody>
</table>
<br>

app/views/home/index.html.erb
<main>
  <section class="py-5 text-center container">
    <div class="row py-lg-5">
      <div class="col-lg-6 col-md-8 mx-auto">
        <h1 class="fw-light">Conference Name XYZ</h1>
        <p class="lead text-muted">This conference is going to happen here and there and if you want to participate by submitting wonderful papers, then why keep waiting, just sign up and begin your journey.</p>
        <p><strong>Venue: </strong>Somewhere on earth</p>
        <p><strong>Submission starts on: </strong>Jan 12, 2021</p>
        <p><strong>Review starts on: </strong>July 1, 2021</p>
        <p class="text-danger"><strong>Submission deadline: </strong>July 20, 2021</p>
        <p class="text-success"><strong>Conference day: </strong>September 30, 2021</p>
        <%= link_to 'Submit Paper', new_paper_path, class: 'btn btn-primary btn-lg mt-3' %>
      </div>
    </div>
  </section>
</main>

app/views/layouts/_alerts.html.erb
<% if notice %>
  <div class="alert alert-dismissible alert-success fade show col-md-6">
    <button type="button" class="btn-close" data-bs-dismiss="alert"></button>
    <%= notice %>
  </div>
<% elsif alert %>
  <div class="alert alert-dismissible alert-warning fade show col-md-6">
    <button type="button" class="btn-close" data-bs-dismiss="alert"></button>
    <%= alert %>
  </div>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RailsConference</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%# <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-KyZXEAg3QhqLMpG8r+8fhAXLRk2vvoC2f3B09zVXn8CA5QIVfZOJ3BCsw2P0p/We" crossorigin="anonymous"> %>
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag "rails-ujs" %>
  </head>
  <body>
    <%= render "home/header" %>
    <div class="container">
      <%= render 'layouts/alerts' %>
      <%= yield %>
    </div>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.0/dist/js/bootstrap.bundle.min.js" integrity="sha384-U1DAWAznBHeqEIlVSCgzq+c9gqGAJn5c/t99JyeKa9xxaYpSvHU5awsuZVVFIhvj" crossorigin="anonymous"></script>
  </body>
</html>

app/views/papers/_form.html.erb
<%= form_with(model: paper) do |form| %>
  <% if paper.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(paper.errors.count, "error") %> prohibited this paper from being saved:</h2>
      <ul>
        <% paper.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>
  <div class="form-group col-md-4">
    <div class="form-label">Paper details</div>
    <div class="field form-floating mb-3">
      <%= form.text_field :title, class: "form-control", placeholder: :title %>
      <%= form.label :title %>
    </div>
    <div class="field form-floating mb-3">
      <%= form.text_area :abstract, id: :abstract, class: "form-control", placeholder: :abstract %>
      <%= form.label :abstract %>
    </div>
    <div class="field form-floating mb-3">
      <%= form.text_field :pdf_link, class: "form-control", placeholder: "Paper URL" %>
      <%= form.label :pdf_link %>
    </div>
    <div class="field">
      <%= form.number_field :user_id, value: current_user.id, type: :hidden %>
    </div>
    <div class="actions">
      <%= form.submit "Submit Paper", class: "btn btn-success btn-lg" %>
    </div>
  </div>
<% end %>

app/views/papers/edit.html.erb
<h1>Editing Paper</h1>
<%= render 'form', paper: @paper %>
<%= link_to 'Show', @paper %> |
<%= link_to 'Back', papers_path %>

app/views/papers/index.html.erb
<% if @papers.empty? %>
  <p>You have not submitted any papers yet.</p>
<% else %>
  <h1>My Papers</h1>
  <table class="table table-hover mt-3">
    <thead>
      <tr class="table-primary ">
        <th scope="col" style="min-width: 20%">Title</th>
        <th scope="col" style="min-width: 10%">Authors</th>
        <th scope="col" style="min-width: 40%">Abstract</th>
        <th scope="col">Pdf link</th>
        <th scope="col">Decision</th>
        <%# <th scope="col">User</th> %>
        <th></th>
      </tr>
    </thead>
    <tbody>
      <% @papers.each do |paper| %>
        <tr>
          <td scope="row"><%= link_to paper.title, paper %></td>
          <td>
            <ol>
              <% paper.users.each do |author| %>
                <li><%= author.first_name %></li>
              <% end %>
            </ol>
          </td>
          <td><%= paper.abstract %></td>
          <td><%= paper.pdf_link %></td>
          <% if paper.decision.blank? %>
            <td>
              <em class="text-danger">Pending</em>
            </td>
          <% else %>
            <td>
              <em class="text-info"><%= paper.decision %></em>
            </td>
          <% end %>
          <td>
            <%= link_to "Edit", edit_paper_path(paper), class: "btn btn-outline-primary btn-sm"%><br>
            <%= link_to "Delete", paper_path(paper), method: :delete, data: { confirm: 'Are you sure?'}, class: "btn btn-outline-danger btn-sm mt-2" %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
  <br>
<% end %>
<%= link_to "Submit New Paper", new_paper_path, class: "btn btn-success btn-lg mt-3" %>

app/views/papers/new.html.erb
<h2>New Submission</h2>
<%= render 'form', paper: @paper %>
<%= link_to 'Back', papers_path, class: "btn btn-info mt-5" %>

app/views/papers/show.html.erb
<p>
  <strong>Title:</strong>
  <%= @paper.title %>
</p>
<p>
  <strong>Abstract:</strong>
  <%= @paper.abstract %>
</p>
<p>
  <strong>Submission date:</strong>
  <%= @paper.submission_date %>
</p>
<p>
  <strong>Pdf link:</strong>
  <%= @paper.pdf_link %>
</p>
<p>
  <strong>Decision:</strong>
  <%= @paper.decision %>
</p>
<%# <p> %>
<%# <strong>Users:</strong> %>
<%# <%= @paper %>
<%# </p> %>
<%= link_to 'Back', papers_path %>